#ifndef _ITKOBJC_RUNTIMETYPES_H
#define _ITKOBJC_RUNTIMETYPES_H

#import <Foundation/NSObject.h>
#import <objc/objc-runtime.h>

/* Type promotion flags */
typedef enum tagItkObjCPromote {
    ItkObjCPromoteArrayPointer = 1,
    ItkObjCPromoteCharInt = 2,
    ItkObjCRegisterId = 4
} ItkObjCPromote;

typedef enum tagItkObjCMsgKind {
    ItkObjCMsgSend, ItkObjCMsgSuper, ItkObjCMsgFormer, ItkObjCMsgObjC
} ItkObjCMsgKind;

typedef struct tagItkObjCFunction {
    void *addr;
    char *types;
} ItkObjCFunction;

typedef struct tagItkObjCVariable {
    void *addr;
    char *type;
} ItkObjCVariable;

@interface NSObject (ItkObjCFormer)
+ (IMP) formerInstanceMethodForSelector: (SEL) sel;
- (IMP) formerMethodForSelector: (SEL) sel;
@end

#endif
