#import <AppKit/AppKit.h>
#import "ITKStdChannel.h"

@interface ITKCommandTextView : NSTextView <ITKStdChannel>
{
    unsigned        commandStart;
    NSDictionary    *commandAttributes, *outputAttributes;
    NSMutableArray  *history;
    int             historyPos;
    NSMutableString *buffer;
    unsigned        modal : 1;
    unsigned        ignoreInsertNewline : 1;
    unsigned        reserved : 30;
}

- (NSDictionary *) commandAttributes;
- (void) setCommandAttributes: (NSDictionary *) attr;
- (NSDictionary *) outputAttributes;
- (void) setOutputAttributes: (NSDictionary *) attr;

- (NSArray *) history;

- (NSString *) command;
- (NSString *) modalCommand;
- (NSRange) commandRange;
- (BOOL) commandIsModal;

- (void) replaceCommandWithString: (NSString *) string;

@end

@interface NSObject (ITKCommandTextViewDelegate)

- (BOOL) commandTextView: (ITKCommandTextView *) commandTextView
     willCompleteCommand: (NSString *) command;

- (void) commandTextView: (ITKCommandTextView *) commandTextView
      didCompleteCommand: (NSString *) command;

@end
