#import <AppKit/AppKit.h>
#import <Foundation/Foundation.h>
#import "ITKCommandTextView.h"

@interface ITKInterp : NSObject
{
    NSString		*initFile;
    ITKCommandTextView	*commandText;
    unsigned		mainInterpProxy : 1;
    unsigned		browserLoaded : 1;
    unsigned		reserved : 30;
}

// The first ITKInterp created by the application (nil if none exists yet).

+ (ITKInterp *) mainInterp;

// Inform ITKInterp about the currently loading nib file.

+ (NSString *) nibFilePath;
+ (void) setNibFilePath: (NSString *) path;

// Access methods

- (NSString *) initFile;
- (void) setInitFile: (NSString *) anInitFile;
- (BOOL) isMainInterpProxy;
- (void) setMainInterpProxy: (BOOL) flag;

// Load init file (abstract)

- (void) loadInitFile: (NSString *) anInitFile;
- (NSString *) scriptFileExtension;

// Command window stuff

- (ITKCommandTextView *) commandTextView;
- (NSWindow *) commandWindow;
- (void) showCommandWindow: sender;
- (void) clearCommandWindow: sender;
- (void) saveCommands: sender;
- (NSString *) commandWindowTitle;
- (NSString *) commandPrompt;
- (NSString *) scriptingLanguage;

// Online help
- (BOOL) showHelpForCommand: (NSString *) command andLanguage: (NSString *) language;

@end
