
if {[objc:info class ITKAspect] != ""} {
# These should eventually be moved into itkObjC's standard macro file.

objc:define ITKSetValue            0x01
objc:define ITKReplaceValue        0x02
objc:define ITKAddValue            0x04
objc:define ITKRemoveValue         0x08
objc:define ITKAllOperations       0x0f
objc:define ITKAspectDidChangeValueNotification \
        [objc:peek -trust [objc:varPtr ITKAspectDidChangeValueNotification] id]

proc itk:declareAspect {aspect} {
    set cap [string toupper [string index $aspect 0]][string range $aspect 1 e]
    set aspect [% $aspect]
    objc:teach NSObject \
    "- TclObj itk$cap {
        \$self tclObjValueOfItkAspect: $aspect
    }
    - void setItk$cap: {TclObj newValue} {
        \$self setTclObjValue: \$newValue ofItkAspect: $aspect
    }"
}

itk:source ItkValue
itk:source ItkSelectedIndex
itk:source ItkAction
itk:source ItkComponent
itk:source ItkData
itk:source ItkDelegate
itk:source ItkEdited
itk:source ItkEnabled
itk:source ItkTag
itk:source ItkTitle
}

#######################################################################
#                             User Startup
########################################################################

if {[file readable ~/.itkRuntimeInit.tcl]} {
    if {[catch {source ~/.itkRuntimeInit.tcl} msg]} {
        puts ".itkRuntimeInit.tcl: $msg"
    }
}
