/* ItkDbg.h - Tcl Debugger include file

Written by: Don Libes, NIST, 3/23/93

Design and implementation of this program was paid for by U.S. tax
dollars.  Therefore it is public domain.  However, the author and NIST
would appreciate credit if this program or parts of it are used.

*/

#ifndef _ITKDBG
#define _ITKDBG

#include <itkTcl/tcl.h>

typedef int (ItkDbg_InterProc) _ANSI_ARGS_((ClientData clientData,
					    Tcl_Interp *interp));
typedef int (ItkDbg_IgnoreFuncsProc) _ANSI_ARGS_((
			ClientData clientData,
			Tcl_Interp *interp,
			char *funcname));
typedef void (ItkDbg_OutputProc) _ANSI_ARGS_((
			ClientData clientData,
			Tcl_Interp *interp,
			char *output));

/* trivial interface, creates a "debug" command in your interp */
#define ItkDbg_Init Itkdbg_Init
#define ItkDbg_SafeInit Itkdbg_SafeInit
EXTERN int ItkDbg_Init _ANSI_ARGS_((Tcl_Interp *));
EXTERN int ItkDbg_SafeInit _ANSI_ARGS_((Tcl_Interp *));

EXTERN void ItkDbg_On _ANSI_ARGS_((Tcl_Interp *interp,
					int immediate));
EXTERN void ItkDbg_Off _ANSI_ARGS_((Tcl_Interp *interp));
EXTERN char **ItkDbg_ArgcArgv _ANSI_ARGS_((int argc,char *argv[],
					int copy));
EXTERN int ItkDbg_Active _ANSI_ARGS_((Tcl_Interp *interp));
EXTERN ItkDbg_InterProc *ItkDbg_Interactor _ANSI_ARGS_((
					Tcl_Interp *interp,
					ItkDbg_InterProc *interactor,
					ClientData clientData));
EXTERN ItkDbg_IgnoreFuncsProc *ItkDbg_IgnoreFuncs _ANSI_ARGS_((
					Tcl_Interp *interp,
					ItkDbg_IgnoreFuncsProc *,
					ClientData clientData));
EXTERN ItkDbg_OutputProc *ItkDbg_Output _ANSI_ARGS_((
					Tcl_Interp *interp,
					ItkDbg_OutputProc *,
					ClientData clientData));
#endif