###############################################################################
#
# (C) 1994 AAA+ Software Forschungs- & Entwicklungs-GmbH.
# All rights reserved.
# 
###############################################################################
#
# 	DESCRIPTION:
#
#	Tcl part of the itkObjC package.
#
###############################################################################

package provide itkObjC 3.0

proc objc:isType {type} {
    expr ![catch {objc:encode $type}]
}

proc objc:expandType {type} {
    objc:decode [objc:encode $type]
}

proc objc:deallocTrace {obj code} {
    upvar #0 ${obj}() dealloc
    set code [list objc:_deallocTrace $code]
    if {[lsearch -exact [trace vinfo dealloc] [list u $code]] == -1} {
	trace variable dealloc u $code
    }
}

proc objc:_deallocTrace {code name index op} {
    if {[catch [concat $code $name] result]} {
	puts "objc:deallocTrace: ignored error result \"$result\""
    }
}

proc cpIn {s} { 
    objc:poke [objc:newPtr "char [expr [clength $s] + 1]"] $s
}

proc cpOut {ptr} {
    set s [objc:peek $ptr {char 0}]
    objc:delPtr $ptr
    return $s
}
